test-lib: fix non-portable pattern bracket expressions

Use a '!' character to start a non-matching pattern bracket expression, as specified by POSIX in Shell Command Language section 2.13.1 Patterns Matching a Single Character [1]. I used '^' instead in three places in the previous three commits, to verify that the arguments of the '--stress=' and '--stress-limit=' options and the values of various '*_PORT' environment variables are valid numbers. With certain shells, at least with dash (upstream and in Ubuntu 14.04) and mksh, this led to various undesired behaviors: # error message in case of a valid number $ ~/src/dash/src/dash ./t3903-stash.sh --stress=8 error: --stress=<N> requires the number of jobs to run # not the expected error message $ ~/src/dash/src/dash ./t3903-stash.sh --stress=foo ./t3903-stash.sh: 238: test: Illegal number: foo # no error message at all?! $ mksh ./t3903-stash.sh --stress=foo $ echo $? 0 Some other shells, e.g. Bash (even in posix mode), ksh, dash in Ubuntu 16.04 or later, are apparently happy to accept '^' just as well. [1] http://pubs.opengroup.org/onlinepubs/009695399/utilities/xcu_chap02.html#tag_02_13 Signed-off-by: SZEDER Gábor <szeder.dev@gmail.com> Signed-off-by: Junio C Hamano <gitster@pobox.com>

SZEDER Gábor committed Feb 11, 2019 at 20:58 UTC 7d661e5ed16dca303d7898f5ab0cc2ffc69e0499
2 files changed +3 -3
t/test-lib-functions.sh
+1 -1
@@ -1289,7 +1289,7 @@ test_set_port () {
1289 port=$(($port + 10000))
1290 fi
1291 ;;
1292 - *[^0-9]*|0*)
1292 + *[!0-9]*|0*)
1293 error >&7 "invalid port number: $port"
1294 ;;
1295 *)
t/test-lib.sh
+2 -2
@@ -144,7 +144,7 @@ do
144 --stress=*)
145 stress=${opt#--*=}
146 case "$stress" in
147 - *[^0-9]*|0*|"")
147 + *[!0-9]*|0*|"")
148 echo "error: --stress=<N> requires the number of jobs to run" >&2
149 exit 1
150 ;;
@@ -155,7 +155,7 @@ do
155 --stress-limit=*)
156 stress_limit=${opt#--*=}
157 case "$stress_limit" in
158 - *[^0-9]*|0*|"")
158 + *[!0-9]*|0*|"")
159 echo "error: --stress-limit=<N> requires the number of repetitions" >&2
160 exit 1
161 ;;